* Example 1
* Estimation of linear regression model with one fixed effect
capture log close
log using example1.log, replace
clear
set more off
set obs 1000

* Generates a random data set
*************************************************
gen x=int(10*uniform())
egen firm=seq(), from(1) to(20) block(50)
gen y=0.5*firm+5*x+0.25*uniform()
sum
*************************************************

* Implementation of the partitioned algorithm

gen fe1=0
forvalues i=1(1)100 {
capture drop ystar
gen double ystar=y-fe1
regress ystar x, nocons
capture drop fe1
gen double temp1=y-_b[x]*x
egen double fe1=mean(temp1), by(firm)
capture drop temp1
}

regress y x i.firm
regress y x fe1
areg y x, absorb(firm)
xtreg y x, i(firm) fe

log close 
