* Example 11
* Estimates Negative Binomial Regression with two fixed effects

log using example11.log, replace
set more off
use ships, clear
xi: nbreg acc op_75_79 i.yr_con i.ship, nolog
keep if e(sample)
egen id1=group(ship)
qui sum id1
local maxg1=r(max)
egen id2=group(yr_con)
qui sum id2
local maxg2=r(max)
local dif=1
local ll1=0
local i=0
gen double off1=0
gen double off2=0
gen double off=0
gen double of1=0
gen double of2=0
while abs(`dif')>epsdouble() {
qui nbreg acc op_75_79, nocons offset(off)
local lna=log(e(alpha))
constraint define 1 [lnalpha]_cons=`lna'
local ll2=`ll1'
local ll1=e(ll)
capture drop xb
predict double xb, xb
qui replace of1=xb-off+off2, nopromote
qui replace of2=xb-off+off1, nopromote
forval j=1/`maxg1' {
qui nbreg acc if id1==`j', offset(of1) constraint(1)
qui replace off1=_b[_cons] if e(sample), nopromote
}
forval j=1/`maxg2' {
qui nbreg acc if id2==`j', offset(of2) constraint(1)
qui replace off2=_b[_cons] if e(sample), nopromote
}
qui replace off=off1+off2
local dif=`ll2'-`ll1'
local i=`i'+1
di "Iter: " `i' "Dif: " `dif'
}
di "Total Number of Iterations -->" `i'
nbreg acc op_75_79, offset(off) nocons
estimates table, b(%10.7f)
xi: nbreg acc op_75_79 i.yr_con i.ship, nolog


