* Example 2
* Estimation of linear regression with one fixed effect (faster approach)
capture log close
log using example2.log, replace
clear
set more off
set obs 1000

* Create a data set
*************************************************
gen x=int(10*uniform())
egen firm=seq(), from(1) to(20) block(50)
gen y=0.5*firm+5*x+0.25*uniform()
sum
*************************************************

* Implementing partitioned algorithm

local dif=1
local ll1=0
gen fe1=0
while abs(`dif')>epsdouble() {
qui regress y x fe1, nocons
local ll2=`ll1'
local ll1=e(ll)
local dif=`ll2'-`ll1'
capture drop fe1
gen double temp1=y-_b[x]*x
egen double fe1=mean(temp1), by(firm)
capture drop temp1
}

areg y x, absorb(firm)
regress y x fe1

log close 
