* Example 3
* Estimation of Linear Regression with two fixed effects
capture log close
log using example3.log, replace
clear
set more off
set obs 1000

* Create a data set
*************************************************
gen rnd=uniform()
gen x=int(10*uniform())
egen firm=seq(), from(1) to(20) block(50)
sort rnd
egen trab=seq(), from(1) to(200) block(5)
gen y=0.5*firm+5*x-0.5*trab+5*uniform()
sum
*************************************************

* Implement partitioned algorithm

local i=0
local dif=1
local ll1=0
gen fe1=0
gen fe2=0
while abs(`dif')>epsdouble() {
qui regress y x fe1 fe2, nocons
local ll2=`ll1'
local ll1=e(ll)
local dif=`ll2'-`ll1'
capture drop fe1
capture drop temp1
gen double temp1=y-_b[x]*x-fe2
egen double fe1=mean(temp1), by(firm)
capture drop fe2
capture drop temp2
gen double temp2=y-_b[x]*x-fe1
egen double fe2=mean(temp2), by(trab)
local i=`i'+1
di "`i'"
}

regress y x i.firm i.trab
areg y x i.firm, absorb(trab)
regress y x fe1 fe2

log close 
