* Example 4
* Estimation of Linear Regression with two fixed effects - faster approach
capture log close
log using example4.log, replace
clear


* Example 4

* Estimates a linear regression with two fixed effects
* Replicates the estimates in Cornelissen 2008, Stata J 8: 170-189.
* felsdvsimul is the ancillary dataset in Cornelissen 2008.
* Uses a faster approach

set more off

use felsdvsimul, clear
gen double temp=0
gen double fe2=0
gen double lastfe2=0
foreach var of varlist y x1 x2 {
quietly {
local i=0
local dif=1
capture drop mean
egen double mean=mean(`var'), by(i)
replace `var'=`var'-mean
while abs(`dif')>epsfloat() {
replace lastfe2=fe2, nopromote
capture drop mean
egen double mean=mean(fe2), by(i)
capture drop fe2
egen double fe2=mean(`var'+mean), by(j)
replace temp=sum(reldif(fe2,lastfe2)), nopromote
local dif=temp[_N]/_N
local i=`i'+1
}
noisily di "Total Number of Iterations for `var' --> " `i'
gen double `var'_res=`var'-fe2+mean
}
}
regress y_res x1_res x2_res, nocons

log close
exit

