* Example 5
* Estimation of standard errors in the Linear Regression with two fixed effects
capture log close
log using example5.log, replace
clear

use felsdvsimul, clear
recast double _all
gen double temp=0
gen double fe2=0
gen double lastfe2=0
foreach var of varlist y x1 x2 {
quietly {
local i=0
local dif=1
capture drop mean
egen double mean=mean(`var'), by(i)
replace `var'=`var'-mean, nopromote
while abs(`dif')>epsdouble() {
replace lastfe2=fe2, nopromote
capture drop mean
egen double mean=mean(fe2), by(i)
capture drop fe2
egen double fe2=mean(`var'+mean), by(j)
replace temp=sum(reldif(fe2,lastfe2)), nopromote
local dif=temp[_N]/_N
di `i' " " `dif'
local i=`i'+1
}
noisily di "Total Number of Iterations for `var' --> " `i'
gen double `var'_res=`var'-fe2+mean
}
}


regress y_res x1_res x2_res, nocons dof(69)

quietly regress y_res x1_res x2_res, nocons mse1
matrix VV=e(V)
predict double res, residual
_robust res, v(VV) minus(31) cluster(g)
di "Clustered standard error of x1 --> " sqrt(VV[1,1])
di "Clustered standard error of x2 --> " sqrt(VV[2,2])
quietly xi: regress y x1 x2 i.i i.j, vce(cluster g)
di "Clustered standard error of x1 --> " _se[x1]
di "Clustered standard error of x2 --> " _se[x2]

log close
exit

