* Example 6
* Estimation of Linear Regression with two fixed effects using reg2hdfe
capture log close
log using example6.log, replace
set more off
clear


* Example 6

* Shows how to use reg2hdfe

use felsdvsimul, clear

* Standard use

reg2hdfe y x1 x2, id1(i) id2(j)

* Storing the fixed effects

reg2hdfe y x1 x2, id1(i) id2(j) fe1(f1) fe2(f2)
regress y x1 x2 f1 f2

* Estimation with a large data set

* First, expurgate the fixed effects from all the variables 
* This is a slow process - but there is a trade-off between tolerance and precision 

reg2hdfe y x1 x2, id1(i) id2(j) tol(0.01) outdata(case1) check
 
* Can improve convergence for single variable

reg2hdfe y, id1(i) id2(j) tol(0.000001) improve(case1) check

* Once satisfied with convergence you can proceed to estimate the final model 
* This should be fast

reg2hdfe y x1 x2, id1(i) id2(j) indata(case1) check

* You can use differente specifications

reg2hdfe y x1, id1(i) id2(j) indata(case1) check

log close
exit

