* Example 7
* Estimation of Linear Regression with 3 fixed effects
capture log close
log using example7.log, replace
clear

use felsdvsimul, clear
sum
generate double temp=0
generate double fe1=0
generate double fe2=0
generate double fe1t=0
generate double fe2t=0
egen double mean=mean(x1), by(x2)
gen double x1t=x1-mean
capture drop mean
egen double mean=mean(y), by(x2)
gen double yt=y-mean
local rss1=0
local dif=1
local i=0
while abs(`dif')>epsdouble() {
quietly {
capture drop mean
egen double mean=mean(fe1), by(x2)
replace fe1t=fe1-mean, nopromote
capture drop mean
egen double mean=mean(fe2), by(x2)
replace fe2t=fe2-mean, nopromote
regress yt x1t fe1t fe2t
local rss2=`rss1'
local rss1=e(rss)
local dif=`rss2'-`rss1'
replace temp=yt-_b[x1t]*x1t+_b[fe1t]*(fe1-fe1t)-_b[fe2t]*fe2t, nopromote
capture drop fe1
egen double fe1=mean(temp), by(i)
replace temp=yt-_b[x1t]*x1t-_b[fe1t]*fe1t+_b[fe2t]*(fe2-fe2t), nopromote
capture drop fe2
egen double fe2=mean(temp), by(j)
local i=`i'+1
}
}
di "Total Number of Iterations --> " `i'
quietly areg y x1 fe1 fe2, absorb(x2)
estimates table, b(%10.7f)

* Now the full ols estimation
quietly xi: regress y x1 i.x2 i.i i.j
estimates table, keep(x1) b(%10.7f) 

log close
exit

